#!/bin/sh

. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh

CURRUPD=$1

if [ "x$CURRUPD" = "x" ]; then
	exit 0
fi
if [ ! -f $TMPDIR/cron.$CURRUPD.tmp ]; then
	exit 0
fi
TMP_FILE3=$TMPDIR/cron.$CURRUPD.tmp
TMP_FILE4=$TMPDIR/$CURRUPD.tmp


if [ "x$CURRUPD" = "xsa" ];then
	echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= Sanesecurity Update =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" > $TMP_FILE4
	echo >> $TMP_FILE4
	echo "Copfilter has updated the Sanesecurity databases for CLAMAV">>$TMP_FILE4
	echo >> $TMP_FILE4
	NOTIF="Sanesecurity"
elif [ "x$CURRUPD" = "xsi" ];then
	echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= SecuriteInfo Update =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" > $TMP_FILE4
	echo >> $TMP_FILE4
	echo "Copfilter has updated the SecuriteInfo databases for CLAMAV">>$TMP_FILE4
	echo >> $TMP_FILE4
	NOTIF="SecuriteInfo"
elif [ "x$CURRUPD" = "xmb" ];then
	echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- MalwarePatrol Update -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" > $TMP_FILE4
	echo >> $TMP_FILE4
	echo "Copfilter has updated the MalwarePatrol databases for CLAMAV">>$TMP_FILE4
	echo >> $TMP_FILE4
	NOTIF="MalwarePatrol"
fi


cat $TMP_FILE3 |sed -e '/----/d'>>$TMP_FILE4
echo >> $TMP_FILE4
echo >> $TMP_FILE4


 
if [ "x${SMTP_HOST}" = "x" -o "x${EMAIL_ADR}" = "x" ] ; then
  echo "no email notification will be sent, since SMTP_HOST and/or EMAIL_ADR where not yet specified" | logger -t "copfilter $NOTIF update for clamav"
else

        if [ "x$SMTP_AUTH_ENABLE" = "xon" ]; then
                echo "smtp authentication enabled, using user: $SMTP_AUTH_USER" | logger -t "copfilter $NOTIF update for clamav"
                cat $TMP_FILE4 | $SENDEMAIL -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
                                -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                                -u "[Copfilter] $NOTIF Update for ClamAV" |logger -t "copfilter $NOTIF update for clamav"
        else
            echo "not using smtp authentication" | logger -t "copfilter $NOTIF update for clamav"
    		cat $TMP_FILE4 |  $SENDEMAIL -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                                -u "[Copfilter] $NOTIF Update for ClamAV" |logger -t "copfilter $NOTIF update for clamav"

        fi
fi

#cleanup
rm -f $TMP_FILE4
