#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#



use strict;
use IO::Socket;
# enable only the following on debugging purpose
use warnings;
use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $lwdb = '';
my $lwsp = '';
my $lwim ='';
my $output = '';
my $bofhland = '';
my $bofcrack = '';
my $bofmal = '';
my $bofphish = '';
my $sanesec ='';
my $filetype = '';
my $phish = '';
my $scam = '';
my $jfld = '';
my $scamnailer = '';
my $spam = '';
my $spamimg = '';
my $lott = '';
my $spear = '';
my $spearl = '';
my $junk = '';
my $jurlbla = '';
my $jurlbl = '';
my $rogue = '';
my $spamattach = '';
my $oitc='';
my $wmal = '';
my $wphsh = '';
my $wpatt = '';
my $wspam = '';
my $wattach = '';
my $bland = '';
my $inet = '';
my $sidb = '';
my $sihon = '';
my $sisecinf = '';
my $sibat = '';
my $sidos = '';
my $sielf = '';
my $sihtm = '';
my $sioff = '';
my $sipdf = '';
my $sish = '';
my $mbl = '';
my $mbldb = '';
my $main = '';
my $daily = '';
my $version = '';
my $safebrowse = '';
my $bytecode = '';
my $msrblim = '';
my $msrblsp = '';
my $msrbldb = '';
my $crdf = '';
my $crdfam = '';

$copfiltersettings{'ACTION'} = '';
$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
&Header::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();






################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_antivirus.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}




################################################################################
##   Antivirus, Antispam
################################################################################

######### CLAMD
$selected{'CLAMD_ENABLE'}{'off'} = '';
$selected{'CLAMD_ENABLE'}{'on'} = '';
$selected{'CLAMD_ENABLE'}{$copfiltersettings{'CLAMD_ENABLE'}} = "selected='selected'";

$selected{'CLAMD_UPDATE_METHOD'}{'manually'} = '';
$selected{'CLAMD_UPDATE_METHOD'}{'periodically'} = '';
$selected{'CLAMD_UPDATE_METHOD'}{$copfiltersettings{'CLAMD_UPDATE_METHOD'}} = "checked='checked'";

$selected{'CLAMD_UPDATE_PERIOD'}{'minutely'} = '';
$selected{'CLAMD_UPDATE_PERIOD'}{'hourly'} = '';
$selected{'CLAMD_UPDATE_PERIOD'}{'daily'} = '';
$selected{'CLAMD_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'CLAMD_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'CLAMD_UPDATE_PERIOD'}{$copfiltersettings{'CLAMD_UPDATE_PERIOD'}} = "selected='selected'";

$selected{'CLAMD_VIRUS_EZIPS'}{'off'} = '';
$selected{'CLAMD_VIRUS_EZIPS'}{'on'} = '';
$selected{'CLAMD_VIRUS_EZIPS'}{$copfiltersettings{'CLAMD_VIRUS_EZIPS'}} = "selected='selected'";

$selected{'CLAMD_PHISHING_SIGS'}{'off'} = '';
$selected{'CLAMD_PHISHING_SIGS'}{'on'} = '';
$selected{'CLAMD_PHISHING_SIGS'}{$copfiltersettings{'CLAMD_PHISHING_SIGS'}} = "selected='selected'";

######### 3rd_party_sigs
$selected{'THRDP_MAIL_NOTIF_ENABLE'}{'off'} = '';
$selected{'THRDP_MAIL_NOTIF_ENABLE'}{'on'} = '';
$selected{'THRDP_MAIL_NOTIF_ENABLE'}{$copfiltersettings{'THRDP_MAIL_NOTIF_ENABLE'}} = "selected='selected'";

$selected{'THRDP_ADD_INFO_ENABLE'}{'off'} = '';
$selected{'THRDP_ADD_INFO_ENABLE'}{'on'} = '';
$selected{'THRDP_ADD_INFO_ENABLE'}{$copfiltersettings{'THRDP_ADD_INFO_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SHOW_GUI_ENABLE'}{'off'} = '';
$selected{'THRDP_SHOW_GUI_ENABLE'}{'on'} = '';
$selected{'THRDP_SHOW_GUI_ENABLE'}{$copfiltersettings{'THRDP_SHOW_GUI_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SPAM_ENABLE'}{'off'} = '';
$selected{'THRDP_SPAM_ENABLE'}{'on'} = '';
$selected{'THRDP_SPAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_SPAM_ENABLE'}{$copfiltersettings{'THRDP_SPAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECURITEINFO_ENABLE'}{'off'} = '';
$selected{'THRDP_SECURITEINFO_ENABLE'}{'on'} = '';
$selected{'THRDP_SECURITEINFO_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECURITEINFO_ENABLE'}{$copfiltersettings{'THRDP_SECURITEINFO_ENABLE'}} = "selected='selected'";

$selected{'THRDP_BOFCRACK_ENABLE'}{'off'} = '';
$selected{'THRDP_BOFCRACK_ENABLE'}{'on'} = '';
$selected{'THRDP_BOFCRACK_ENABLE'}{'havp'} = '';
$selected{'THRDP_BOFCRACK_ENABLE'}{$copfiltersettings{'THRDP_BOFCRACK_ENABLE'}} = "selected='selected'";

$selected{'THRDP_BOFMAL_ENABLE'}{'off'} = '';
$selected{'THRDP_BOFMAL_ENABLE'}{'on'} = '';
$selected{'THRDP_BOFMAL_ENABLE'}{'havp'} = '';
$selected{'THRDP_BOFMAL_ENABLE'}{$copfiltersettings{'THRDP_BOFMAL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_BOFPHSH_ENABLE'}{'off'} = '';
$selected{'THRDP_BOFPHSH_ENABLE'}{'on'} = '';
$selected{'THRDP_BOFPHSH_ENABLE'}{'havp'} = '';
$selected{'THRDP_BOFPHSH_ENABLE'}{$copfiltersettings{'THRDP_BOFPHSH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WSPAM_ENABLE'}{'off'} = '';
$selected{'THRDP_WSPAM_ENABLE'}{'on'} = '';
$selected{'THRDP_WSPAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_WSPAM_ENABLE'}{$copfiltersettings{'THRDP_WSPAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WATTACH_ENABLE'}{'off'} = '';
$selected{'THRDP_WATTACH_ENABLE'}{'on'} = '';
$selected{'THRDP_WATTACH_ENABLE'}{'havp'} = '';
$selected{'THRDP_WATTACH_ENABLE'}{$copfiltersettings{'THRDP_WATTACH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_MSRBL_SPAM_ENABLE'}{'off'} = '';
$selected{'THRDP_MSRBL_SPAM_ENABLE'}{'on'} = '';
$selected{'THRDP_MSRBL_SPAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_MSRBL_SPAM_ENABLE'}{$copfiltersettings{'THRDP_MSRBL_SPAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SPAMIMG_ENABLE'}{'off'} = '';
$selected{'THRDP_SPAMIMG_ENABLE'}{'on'} = '';
$selected{'THRDP_SPAMIMG_ENABLE'}{'havp'} = '';
$selected{'THRDP_SPAMIMG_ENABLE'}{$copfiltersettings{'THRDP_SPAMIMG_ENABLE'}} = "selected='selected'";

$selected{'THRDP_FILETYPE_ENABLE'}{'off'} = '';
$selected{'THRDP_FILETYPE_ENABLE'}{'on'} = '';
$selected{'THRDP_FILETYPE_ENABLE'}{'havp'} = '';
$selected{'THRDP_FILETYPE_ENABLE'}{$copfiltersettings{'THRDP_FILETYPE_ENABLE'}} = "selected='selected'";

$selected{'THRDP_HONEYNET_ENABLE'}{'off'} = '';
$selected{'THRDP_HONEYNET_ENABLE'}{'on'} = '';
$selected{'THRDP_HONEYNET_ENABLE'}{'havp'} = '';
$selected{'THRDP_HONEYNET_ENABLE'}{$copfiltersettings{'THRDP_HONEYNET_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WPHSH_ENABLE'}{'off'} = '';
$selected{'THRDP_WPHSH_ENABLE'}{'on'} = '';
$selected{'THRDP_WPHSH_ENABLE'}{'havp'} = '';
$selected{'THRDP_WPHSH_ENABLE'}{$copfiltersettings{'THRDP_WPHSH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_MSRBL_IMAGES_ENABLE'}{'off'} = '';
$selected{'THRDP_MSRBL_IMAGES_ENABLE'}{'on'} = '';
$selected{'THRDP_MSRBL_IMAGES_ENABLE'}{'havp'} = '';
$selected{'THRDP_MSRBL_IMAGES_ENABLE'}{$copfiltersettings{'THRDP_MSRBL_IMAGES_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOBAT_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOBAT_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOBAT_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOBAT_ENABLE'}{$copfiltersettings{'THRDP_SECINFOBAT_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WMAL_ENABLE'}{'off'} = '';
$selected{'THRDP_WMAL_ENABLE'}{'on'} = '';
$selected{'THRDP_WMAL_ENABLE'}{'havp'} = '';
$selected{'THRDP_WMAL_ENABLE'}{$copfiltersettings{'THRDP_WMAL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_LOTT_ENABLE'}{'off'} = '';
$selected{'THRDP_LOTT_ENABLE'}{'on'} = '';
$selected{'THRDP_LOTT_ENABLE'}{'havp'} = '';
$selected{'THRDP_LOTT_ENABLE'}{$copfiltersettings{'THRDP_LOTT_ENABLE'}} = "selected='selected'";

$selected{'THRDP_CRDFAM_ENABLE'}{'off'} = '';
$selected{'THRDP_CRDFAM_ENABLE'}{'on'} = '';
$selected{'THRDP_CRDFAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_CRDFAM_ENABLE'}{$copfiltersettings{'THRDP_CRDFAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFODOS_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFODOS_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFODOS_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFODOS_ENABLE'}{$copfiltersettings{'THRDP_SECINFODOS_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WPATT_ENABLE'}{'off'} = '';
$selected{'THRDP_WPATT_ENABLE'}{'on'} = '';
$selected{'THRDP_WPATT_ENABLE'}{'havp'} = '';
$selected{'THRDP_WPATT_ENABLE'}{$copfiltersettings{'THRDP_WPATT_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SPAMATTACH_ENABLE'}{'off'} = '';
$selected{'THRDP_SPAMATTACH_ENABLE'}{'on'} = '';
$selected{'THRDP_SPAMATTACH_ENABLE'}{'havp'} = '';
$selected{'THRDP_SPAMATTACH_ENABLE'}{$copfiltersettings{'THRDP_SPAMATTACH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SPEAR_ENABLE'}{'off'} = '';
$selected{'THRDP_SPEAR_ENABLE'}{'on'} = '';
$selected{'THRDP_SPEAR_ENABLE'}{'havp'} = '';
$selected{'THRDP_SPEAR_ENABLE'}{$copfiltersettings{'THRDP_SPEAR_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOELF_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOELF_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOELF_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOELF_ENABLE'}{$copfiltersettings{'THRDP_SECINFOELF_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SPEARL_ENABLE'}{'off'} = '';
$selected{'THRDP_SPEARL_ENABLE'}{'on'} = '';
$selected{'THRDP_SPEARL_ENABLE'}{'havp'} = '';
$selected{'THRDP_SPEARL_ENABLE'}{$copfiltersettings{'THRDP_SPEARL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_JURLBL_ENABLE'}{'off'} = '';
$selected{'THRDP_JURLBL_ENABLE'}{'on'} = '';
$selected{'THRDP_JURLBL_ENABLE'}{'havp'} = '';
$selected{'THRDP_JURLBL_ENABLE'}{$copfiltersettings{'THRDP_JURLBL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_JUNK_ENABLE'}{'off'} = '';
$selected{'THRDP_JUNK_ENABLE'}{'on'} = '';
$selected{'THRDP_JUNK_ENABLE'}{'havp'} = '';
$selected{'THRDP_JUNK_ENABLE'}{$copfiltersettings{'THRDP_JUNK_ENABLE'}} = "selected='selected'";

$selected{'THRDP_MBL_ENABLE'}{'off'} = '';
$selected{'THRDP_MBL_ENABLE'}{'on'} = '';
$selected{'THRDP_MBL_ENABLE'}{'havp'} = '';
$selected{'THRDP_MBL_ENABLE'}{$copfiltersettings{'THRDP_MBL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOHTM_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOHTM_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOHTM_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOHTM_ENABLE'}{$copfiltersettings{'THRDP_SECINFOHTM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SCAMNAILER_ENABLE'}{'off'} = '';
$selected{'THRDP_SCAMNAILER_ENABLE'}{'on'} = '';
$selected{'THRDP_SCAMNAILER_ENABLE'}{'havp'} = '';
$selected{'THRDP_SCAMNAILER_ENABLE'}{$copfiltersettings{'THRDP_SCAMNAILER_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOOFF_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOOFF_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOOFF_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOOFF_ENABLE'}{$copfiltersettings{'THRDP_SECINFOOFF_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOSH_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOSH_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOSH_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOSH_ENABLE'}{$copfiltersettings{'THRDP_SECINFOSH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SCAM_ENABLE'}{'off'} = '';
$selected{'THRDP_SCAM_ENABLE'}{'on'} = '';
$selected{'THRDP_SCAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_SCAM_ENABLE'}{$copfiltersettings{'THRDP_SCAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOPDF_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOPDF_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOPDF_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOPDF_ENABLE'}{$copfiltersettings{'THRDP_SECINFOPDF_ENABLE'}} = "selected='selected'";

$selected{'THRDP_PHISH_ENABLE'}{'off'} = '';
$selected{'THRDP_PHISH_ENABLE'}{'on'} = '';
$selected{'THRDP_PHISH_ENABLE'}{'havp'} = '';
$selected{'THRDP_PHISH_ENABLE'}{$copfiltersettings{'THRDP_PHISH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_INET_ENABLE'}{'off'} = '';
$selected{'THRDP_INET_ENABLE'}{'on'} = '';
$selected{'THRDP_INET_ENABLE'}{'havp'} = '';
$selected{'THRDP_INET_ENABLE'}{$copfiltersettings{'THRDP_INET_ENABLE'}} = "selected='selected'";

$selected{'THRDP_LW_SCAM_ENABLE'}{'off'} = '';
$selected{'THRDP_LW_SCAM_ENABLE'}{'on'} = '';
$selected{'THRDP_LW_SCAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_LW_SCAM_ENABLE'}{$copfiltersettings{'THRDP_LW_SCAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_ROGUE_ENABLE'}{'off'} = '';
$selected{'THRDP_ROGUE_ENABLE'}{'on'} = '';
$selected{'THRDP_ROGUE_ENABLE'}{'havp'} = '';
$selected{'THRDP_ROGUE_ENABLE'}{$copfiltersettings{'THRDP_ROGUE_ENABLE'}} = "selected='selected'";

$selected{'THRDP_LW_IMAGE_ENABLE'}{'off'} = '';
$selected{'THRDP_LW_IMAGE_ENABLE'}{'on'} = '';
$selected{'THRDP_LW_IMAGE_ENABLE'}{'havp'} = '';
$selected{'THRDP_LW_IMAGE_ENABLE'}{$copfiltersettings{'THRDP_LW_IMAGE_ENABLE'}} = "selected='selected'";

$selected{'THRDP_JURLBLA_ENABLE'}{'off'} = '';
$selected{'THRDP_JURLBLA_ENABLE'}{'on'} = '';
$selected{'THRDP_JURLBLA_ENABLE'}{'havp'} = '';
$selected{'THRDP_JURLBLA_ENABLE'}{$copfiltersettings{'THRDP_JURLBLA_ENABLE'}} = "selected='selected'";

######### FPROT
$selected{'FPROT_ENABLE'}{'off'} = '';
$selected{'FPROT_ENABLE'}{'on'} = '';
$selected{'FPROT_ENABLE'}{$copfiltersettings{'FPROT_ENABLE'}} = "selected='selected'";

$selected{'FPROT_UPDATE_METHOD'}{'manually'} = '';
$selected{'FPROT_UPDATE_METHOD'}{'periodically'} = '';
$selected{'FPROT_UPDATE_METHOD'}{$copfiltersettings{'FPROT_UPDATE_METHOD'}} = "checked='checked'";

$selected{'FPROT_UPDATE_PERIOD'}{'minutely'} = '';
$selected{'FPROT_UPDATE_PERIOD'}{'hourly'} = '';
$selected{'FPROT_UPDATE_PERIOD'}{'daily'} = '';
$selected{'FPROT_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'FPROT_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'FPROT_UPDATE_PERIOD'}{$copfiltersettings{'FPROT_UPDATE_PERIOD'}} = "selected='selected'";



######### AVG
$selected{'AVG_ENABLE'}{'off'} = '';
$selected{'AVG_ENABLE'}{'on'} = '';
$selected{'AVG_ENABLE'}{$copfiltersettings{'AVG_ENABLE'}} = "selected='selected'";

$selected{'AVG_UPDATE_METHOD'}{'manually'} = '';
$selected{'AVG_UPDATE_METHOD'}{'periodically'} = '';
$selected{'AVG_UPDATE_METHOD'}{$copfiltersettings{'AVG_UPDATE_METHOD'}} = "checked='checked'";

$selected{'AVG_UPDATE_PERIOD'}{'minutely'} = '';
$selected{'AVG_UPDATE_PERIOD'}{'hourly'} = '';
$selected{'AVG_UPDATE_PERIOD'}{'daily'} = '';
$selected{'AVG_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'AVG_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'AVG_UPDATE_PERIOD'}{$copfiltersettings{'AVG_UPDATE_PERIOD'}} = "selected='selected'";



################################################################################
##   ACTIONs
################################################################################


if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter clamd update now'})
{
        system ('/usr/local/bin/copfilter_check-updates_clamav 2>&1 |logger -t "copfilter clamd update now" &');
        system ('/bin/touch', "${copfilter_swroot}/etc/copfilter_check-updates_clamav.done");
        $copfiltersettings{'ACTION'} = '';
}

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter avg update now'})
{
        system ('/usr/local/bin/copfilter_check-updates_avg 2>&1 |logger -t "copfilter avg update now" &');
        system ('/bin/touch', "${copfilter_swroot}/etc/copfilter_check-updates_avg.done");
        $copfiltersettings{'ACTION'} = '';
}

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter fprot update now'})
{
        system ('/usr/local/bin/copfilter_check-updates_f-prot 2>&1 |logger -t "copfilter fprot update now" &');
        system ('/bin/touch', "${copfilter_swroot}/etc/copfilter_check-updates_f-prot.done");
        $copfiltersettings{'ACTION'} = '';
}




######### send quarantined email
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter send q_mail'} )
{
        &copfilter_start_log();
        &writehashsorted("/tmp/env_send_q_mail.tmp", \%copfiltersettings);
        system ('/usr/local/bin/copfilter_send_q_mail');
        &copfilter_stop_log();
}




use File::stat;
use Time::localtime;



######### Show virus quarantine
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter show virus quarantine'} )
{
        &copfilter_start_log();

if (system ("ls /var/log/copfilter/default/opt/p3scan/quarantine >/dev/null 2>&1") eq 0 )
{

my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2);
$dir = "/var/log/copfilter/default/opt/p3scan/quarantine";
print "<br />\n";
print "<b>$Lang::tr{'copfilter show virus quarantine'} - POP3 - $dir</b>\n";
print "<form method='post' action='/cgi-bin/copfilter_antivirus.cgi' enctype='multipart/form-data'>\n";
print "<table width='100%' cellpadding='2' cellspacing='0' color='#ffffff' border='1'>\n";
print "<TR>\n";
print "<td align='center'>del</td>\n";
print "<td align='center'>send</td>\n";
print "<td align='center'> $Lang::tr{'copfilter q_from'}      </td>\n";
print "<td align='center'> $Lang::tr{'copfilter q_to'}       </td>\n";
print "<td align='center'> $Lang::tr{'copfilter q_subject'}  </td>\n";
print "<td align='center'> $Lang::tr{'copfilter q_virusname'}     </td>\n";
print "<td align='center'> $Lang::tr{'copfilter q_date'}     </td>\n";
print "<td align='center'> $Lang::tr{'copfilter q_filename'} </td>\n";
print "</TR>\n";
opendir(BIN, $dir) or die "Can't open $dir: $!";
#while( defined ($file = readdir(BIN))) {
foreach my $file (grep {/\.virus$/} readdir BIN){
   $hit = 0;
   $subject = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";

   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
         if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;

#            $_ =~ s/$1/.+<from:(.+)>/i;
#            $_ =~ s/.*(([A-Z0-9]+[._]?){1,}[A-Z0-9]+\@(([A-Z0-9]+[-]?){1,}[A-Z0-9]+\.){1,}[A-Z]{2,4}).*/$1/i;
#            $_ =~ s/.*(@).*/$1/i;
#            $_ =~ s/.*(\b\[A-Z0-9._%-\]++@\[A-Z0-9._%-\]+\.\[A-Z\]\{2,4\}\b).*/$1/i;
#            $_ =~ s/[ .><]*([0-9a-zA-Z-.]+\@[-.\w]+\.\w{2,3}\W)[ <>.]*/$1/i;
##             $_ = ~ /^From:\s([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)$/

            $sender = $_;
         }
#         if (/Envelope-To:/i) {
         if (/^To: /i) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }
         if (/^Subject: /i) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }


      }

      my ($sec, $tm, $virusfilename, $virusname);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 0, 70);
      $recipient2 =  substr($recipient, 0, 30);
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);
      print "<TR>\n";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.delete' /></td>";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file' /></td>";
      print "<td class='base' align='left'>$sender2</td>";
      print "<td class='base' align='left'>$recipient2</td>";
      print "<td class='base' align='left'>$subject2</td>";
      print "<td class='base' align='left'>";

      $virusfilename = "$dir/$file\.name";        # Name the file

      open(VIRUSNAME, $virusfilename);        # Open the file
      $virusname = <VIRUSNAME>;      # Read it into an array
      close(VIRUSNAME);          # Close the file
      print $virusname;         # Print the array

      print "</td>";
      print "<td class='base' align='left'>";

      $tm = localtime($sec);
      printf("%04d%02d%02d_%02d:%02d:%02d\n",
      $tm->year+1900, $tm->mon+1, $tm->mday,
      $tm->hour, $tm->min, $tm->sec);
      print "</td>";
      print "<td class='base' align='left'><a href='/p3scan_quarantine/$file' target='_blank'>$file2</a></td>";
      print "</TR>";

   }
}
closedir(BIN);
        print "</table>";

}
else
{
print "<br /><P> $Lang::tr{'copfilter show quarantine error'} \n";
print "/var/log/copfilter/default/opt/p3scan/quarantine</P>\n";
}

print "<br />\n";
print "<br />\n";
print "<br />\n";


if ( system ("ls /var/log/copfilter/default/opt/proxsmtp/quarantine >/dev/null 2>&1") eq 0 )
{
    my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2);
    $dir = "/var/log/copfilter/default/opt/proxsmtp/quarantine";
    print "<b>$Lang::tr{'copfilter show virus quarantine'} - SMTP - $dir</b>\n";
    print "<table width='100%' cellpadding='2' cellspacing='0' color='#ffffff' border='1'>\n";
    print "<TR>\n";
    print "<td align='center'>del</td>\n";
    print "<td align='center'>send</td>\n";
    print "<td align='center'> $Lang::tr{'copfilter q_from'}      </td>\n";
    print "<td align='center'> $Lang::tr{'copfilter q_to'}       </td>\n";
    print "<td align='center'> $Lang::tr{'copfilter q_subject'}  </td>\n";
    print "<td align='center'> $Lang::tr{'copfilter q_virusname'}     </td>\n";
    print "<td align='center'> $Lang::tr{'copfilter q_date'}     </td>\n";
    print "<td align='center'> $Lang::tr{'copfilter q_filename'} </td>\n";
    print "</TR>\n";
    opendir(BIN, $dir) or die "Can't open $dir: $!";
    #while( defined ($file = readdir(BIN))) {
    foreach my $file (grep {/\.virus$/} readdir BIN){
       $hit = 0;
       $subject = "";
       $sender = "";
       $recipient = "";
       $date = "";
       $hit = 1 if -T "$dir/$file";

       if ($hit == 1) {
          open (EP,"$dir/$file");
          while (<EP>) {
         if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;

#            $_ =~ s/$1/.+<from:(.+)>/i;
#            $_ =~ s/.*(([A-Z0-9]+[._]?){1,}[A-Z0-9]+\@(([A-Z0-9]+[-]?){1,}[A-Z0-9]+\.){1,}[A-Z]{2,4}).*/$1/i;
#            $_ =~ s/.*(@).*/$1/i;
#            $_ =~ s/.*(\b\[A-Z0-9._%-\]++@\[A-Z0-9._%-\]+\.\[A-Z\]\{2,4\}\b).*/$1/i;
#            $_ =~ s/[ .><]*([0-9a-zA-Z-.]+\@[-.\w]+\.\w{2,3}\W)[ <>.]*/$1/i;
##             $_ = ~ /^From:\s([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)$/

            $sender = $_;
         }
#         if (/Envelope-To:/i) {
         if (/^To: /i) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }
         if (/^Subject: /i) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }


          }

      my ($sec, $tm, $virusfilename, $virusname);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 0, 70);
      $recipient2 =  substr($recipient, 0, 30);
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 16);
      print "<TR>\n";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.delete' /></td>";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file' /></td>";
      print "<td class='base' align='left'>$sender2</td>";
      print "<td class='base' align='left'>$recipient2</td>";
      print "<td class='base' align='left'>$subject2</td>";
      print "<td class='base' align='left'>";

      $virusfilename = "$dir/$file\.name";        # Name the file

      open(VIRUSNAME, $virusfilename);        # Open the file
      $virusname = <VIRUSNAME>;      # Read it into an array
      close(VIRUSNAME);          # Close the file
      print $virusname;         # Print the array

      print "</td>";
      print "<td class='base' align='left'>";

      $tm = localtime($sec);
      printf("%04d%02d%02d_%02d:%02d:%02d\n",
      $tm->year+1900, $tm->mon+1, $tm->mday,
      $tm->hour, $tm->min, $tm->sec);
      print "</td>";
      print "<td class='base' align='left'><a href='/proxsmtp_quarantine/$file' target='_blank'>$file2</a></td>";
      print "</TR>";

       }
    }
    closedir(BIN);

    print <<END
    </table><br /><br />

    <table border='0'>
    <tr><td> del ... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail6'}</td></tr>
    <tr><td> send ... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail4'}</td></tr>
    </table><br /><br />

    <table border='0'>
    <tr><td>
           <input type='checkbox' name='DELETE_ALL_VIRUS' /> $Lang::tr{'copfilter send q_mail2'}
       </td>
    </tr>

    <tr><td>
            &nbsp;
       </td>
    </tr>

    <tr><td>
           <input type='submit' name='ACTION' value='$Lang::tr{'copfilter send q_mail'}' />
       </td>

       <td width=15 >
            &nbsp;
       </td>
    </tr>
    </table>
    </form>

END
;


}
else
{
print "<br /><P>$Lang::tr{'copfilter show quarantine error'} \n";
print "/var/log/copfilter/default/opt/proxsmtp/quarantine</P>\n";
}
        &copfilter_stop_log();
}







######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{ 

################################################################################
##   Checking input values
################################################################################

          if ($copfiltersettings{'IM_SCAN'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'IMSPECTOR_PROXY_GREEN'} !~ /^(on|off)$/ ||
#	    $copfiltersettings{'IMSPECTOR_PROXY_ORANGE'} !~ /^(on|off)$/ ||
#	    $copfiltersettings{'IMSPECTOR_PROXY_BLUE'} !~ /^(on|off)$/ ||
#3rd_party_sigs
	    $copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'THRDP_MAIL_NOTIF_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'THRDP_ADD_INFO_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'THRDP_MSRBL_SPAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SPAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_FILETYPE_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SPAMATTACH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECURITEINFO_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WSPAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_MSRBL_IMAGES_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SPAMIMG_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_HONEYNET_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_BOFPHSH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_BOFMAL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_BOFCRACK_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WPHSH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WATTACH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_LOTT_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOBAT_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WMAL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_CRDFAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SPEAR_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFODOS_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SPEARL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOELF_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WPATT_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOHTM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_MBL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_JURLBLA_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_JURLBL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SCAMNAILER_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_JUNK_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SCAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOOFF_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_INET_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_LW_SCAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOPDF_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOSH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_PHISH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_ROGUE_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_LW_IMAGE_ENABLE'} !~ /^(on|off|havp)$/ || 
#3rd_party_sigs_ende
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'AVG_ENABLE'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 

        if (!($copfiltersettings{'CLAMD_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'CLAMD_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid clamd time period'};
                goto ERROR;
        }


        if (!($copfiltersettings{'FPROT_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'FPROT_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid fprot time period'};
                goto ERROR;
        }

        if (!($copfiltersettings{'AVG_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'AVG_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid avg time period'};
                goto ERROR;
        }


ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }



################################################################################
##   set update values
################################################################################


        # CLAMAV
        my ($clamd_updateperiod)=();

        if  ($copfiltersettings{'CLAMD_UPDATE_PERIOD'} eq 'hourly') {
        	$clamd_updateperiod = $copfiltersettings{'CLAMD_UPDATE_VALUE'} * 60; }
        elsif  ($copfiltersettings{'CLAMD_UPDATE_PERIOD'} eq 'daily') {
        	$clamd_updateperiod = $copfiltersettings{'CLAMD_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'CLAMD_UPDATE_PERIOD'} eq 'weekly') {
        	$clamd_updateperiod = $copfiltersettings{'CLAMD_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'CLAMD_UPDATE_PERIOD'} eq 'monthly') {
        	$clamd_updateperiod = $copfiltersettings{'CLAMD_UPDATE_VALUE'} * 40320; }
        else {
        	$clamd_updateperiod = $copfiltersettings{'CLAMD_UPDATE_VALUE'} * 1; }

        $clamd_updateperiod = $clamd_updateperiod - 5;

        if ($clamd_updateperiod <= 5) {
        	$clamd_updateperiod = 5; }

        open(FILE, ">/${copfilter_swroot}/etc/clamd_counter.conf") or die $Lang::tr{'copfilter clamd_counter'};
        flock(FILE, 2);
        print FILE "$clamd_updateperiod\n";
        close FILE;


        # F-PROT
        my ($fprot_updateperiod)=();

        if  ($copfiltersettings{'FPROT_UPDATE_PERIOD'} eq 'hourly') {
        	$fprot_updateperiod = $copfiltersettings{'FPROT_UPDATE_VALUE'} * 60; }
        elsif  ($copfiltersettings{'FPROT_UPDATE_PERIOD'} eq 'daily') {
        	$fprot_updateperiod = $copfiltersettings{'FPROT_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'FPROT_UPDATE_PERIOD'} eq 'weekly') {
        	$fprot_updateperiod = $copfiltersettings{'FPROT_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'FPROT_UPDATE_PERIOD'} eq 'monthly') {
        	$fprot_updateperiod = $copfiltersettings{'FPROT_UPDATE_VALUE'} * 40320; }
        else {
        	$fprot_updateperiod = $copfiltersettings{'FPROT_UPDATE_VALUE'} * 1; }

        $fprot_updateperiod = $fprot_updateperiod - 5;

        if ($fprot_updateperiod <= 5) {
        	$fprot_updateperiod = 5; }

        open(FILE, ">/${copfilter_swroot}/etc/fprot_counter.conf") or die $Lang::tr{'copfilter fprot_counter'};
        flock(FILE, 2);
        print FILE "$fprot_updateperiod\n";
        close FILE;



        # AVG
        my ($avg_updateperiod)=();

        if  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'hourly') {
        	$avg_updateperiod = $copfiltersettings{'AVG_UPDATE_VALUE'} * 60; }
        elsif  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'daily') {
        	$avg_updateperiod = $copfiltersettings{'AVG_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'weekly') {
        	$avg_updateperiod = $copfiltersettings{'AVG_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'monthly') {
        	$avg_updateperiod = $copfiltersettings{'AVG_UPDATE_VALUE'} * 40320; }
        else {
        	$avg_updateperiod = $copfiltersettings{'AVG_UPDATE_VALUE'} * 1; }

        $avg_updateperiod = $avg_updateperiod - 5;

        if ($avg_updateperiod <= 5) {
        	$avg_updateperiod = 5; }

        open(FILE, ">/${copfilter_swroot}/etc/avg_counter.conf") or die $Lang::tr{'copfilter avg_counter'};
        flock(FILE, 2);
        print FILE "$avg_updateperiod\n";
        close FILE;






################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

	    unlink "${copfilter_swroot}/etc/clamd_enable";
	    unlink "${copfilter_swroot}/etc/avg_enable";
	    unlink "${copfilter_swroot}/etc/fprotd_enable";

       	    if ($copfiltersettings{'CLAMD_ENABLE'} eq 'on') {
			system ('/bin/touch', "${copfilter_swroot}/etc/clamd_enable"); }

            if ( -e "${copfilter_swroot}/opt/avg/default/bin/avgscan") {
                if ($copfiltersettings{'AVG_ENABLE'} eq 'on') {
                system ('/bin/touch', "${copfilter_swroot}/etc/avg_enable"); }
            }

            if ( -e "${copfilter_swroot}/opt/f-prot/default/fpscan") {
                if ($copfiltersettings{'FPROT_ENABLE'} eq 'on') {
                system ('/bin/touch', "${copfilter_swroot}/etc/fprotd_enable"); }
            }


           if ( ! -e "${copfilter_swroot}/etc/clamd_counter") {
                if ($copfiltersettings{'CLAMD_UPDATE_METHOD'} eq 'periodically')
                {
                        open(FILE, ">/${copfilter_swroot}/etc/clamd_counter") or die "Unable to write clamd_counter file";
                        flock(FILE, 2);
                        print FILE "$clamd_updateperiod\n";
                        close FILE;
                }
           }

           if ( ! -e "${copfilter_swroot}/etc/fprot_counter") {
                if ($copfiltersettings{'FPROT_UPDATE_METHOD'} eq 'periodically')
                {
                        open(FILE, ">/${copfilter_swroot}/etc/fprot_counter") or die "Unable to write fprot_counter file";
                        flock(FILE, 2);
                        print FILE "$fprot_updateperiod\n";
                        close FILE;
                }
           }

           if ( ! -e "${copfilter_swroot}/etc/avg_counter") {
                if ($copfiltersettings{'AVG_UPDATE_METHOD'} eq 'periodically')
                {
                        open(FILE, ">/${copfilter_swroot}/etc/avg_counter") or die "Unable to write avg_counter file";
                        flock(FILE, 2);
                        print FILE "$avg_updateperiod\n";
                        close FILE;
                }
           }

# if setting were valid, write settings and reconfigure

         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
        if ( ! ($copfiltersettings{'SKIP_RESTART'} eq 'on' )) {
            &copfilter_start_log(); 
            print "<br /><b>$Lang::tr{'copfilter restart0'} clamd..</b> <br />";
            system('/usr/local/bin/copfilter_restartclamd');

            if ( -e "${copfilter_swroot}/opt/avg/default/bin/avgscan") {
                print "<br /><b>$Lang::tr{'copfilter restart0'} avgscan..</b> <br />";
                system('/usr/local/bin/copfilter_restartavgscan');
            }

            if ( -e "${copfilter_swroot}/opt/f-prot/default/fpscand") {
                print "<br /><b>$Lang::tr{'copfilter restart0'} fpscand..</b> <br />";
                system('/usr/local/bin/copfilter_restartf-protd');
            }

            print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
            system('/usr/local/bin/copfilter_restarthavp');

            print "<br /><br /><b>$Lang::tr{'copfilter restart0'} frox..</b> <br />";
            system('/usr/local/bin/copfilter_restartfrox');

            print "<br /><b>$Lang::tr{'copfilter restart0'} monit..</b> <br />";
            system('/usr/local/bin/copfilter_restartmonit');
            &copfilter_stop_log(); 
        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


}





################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "&nbsp;</class>\n";
    &Header::closebox();
}




################################################################################
##  Website - AntiVirus
################################################################################
print "<a name='antivirus'/>";

&Header::openbox('100%', 'left', "$Lang::tr{'copfilter antivirus'} (ClamAV, AVG, F-Prot):");


print "<form method='post' action='/cgi-bin/copfilter_antivirus.cgi' enctype='multipart/form-data'>";

##### ClamAV

print <<END
<table border='0' cellpadding='2'>
<tr>
        <td width='72'></td>
        <td width='100'></td>
        <td width='130'></td>
        <td width='50'></td>
        <td width='50'></td>
        <td width='70'></td>
</tr>


<tr>
	<td><u><b>ClamAV:</b></u></td>
       	<td> <select name='CLAMD_ENABLE'>
             <option value='on' $selected{'CLAMD_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'CLAMD_ENABLE'}{'off'}>off</option> </select> * </td>
    <td>$Lang::tr{'copfilter clamd virus ezips'}</td>
    <td> <select name='CLAMD_VIRUS_EZIPS'>
             <option value='on' $selected{'CLAMD_VIRUS_EZIPS'}{'on'}>on</option>
             <option value='off' $selected{'CLAMD_VIRUS_EZIPS'}{'off'}>off</option> </select>
    </td>
    <td>&nbsp; </td>
        <td colspan='1'> $Lang::tr{'copfilter clamstats'} </td>
        <td colspan='1'> $Lang::tr{'copfilter clamstats2'} </td>
</tr>
</table>
<table width='100%' border='0' cellpadding='2'>
<tr>
        <td width='28%'></td>
        <td width='5%'></td>
        <td width='23%'></td>
        <td width='24%'></td>
        <td width='20%'></td>
</tr>
<tr>
        <td colspan='2'><b>$Lang::tr{'copfilter clam_sig'}:</b></td>
        <td colspan='2'><b>$Lang::tr{'copfilter automatic update'}:</b></td>
        <td colspan='1'><b>$Lang::tr{'copfilter manual update'}:</b></td>
</tr>
<tr>
        <td colspan='2'>
END
;

########### ClamAV START ######################
# ClamAV Version und Version der aktuellen Signaturen
$version = `/var/log/copfilter/default/opt/clamav/default/sbin/clamd -V | cut -d "/" -f 1`;
$main = `cat /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION |/bin/grep -E "^main" | cut -d ":" -f 2 | cut -d "," -f 1 | cut -d " " -f 2`;
$daily = `cat /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION |/bin/grep -E "^daily" | cut -d ":" -f 2 | cut -d "," -f 1 | cut -d " " -f 2`;
$safebrowse = `cat /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION |/bin/grep -E "^safebrowsing" | cut -d ":" -f 2 | cut -d "," -f 1 | cut -d " " -f 2`;
$bytecode = `cat /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION |/bin/grep -E "^bytecode" | cut -d ":" -f 2 | cut -d "," -f 1 | cut -d " " -f 2`;
$output = "$version\/ main $main\/ daily $daily";
if ( ! $bytecode eq ''){
	$output = "$output\/ bytecode $bytecode";
}
if ( ! $safebrowse eq ''){
	$output = "$output\/ safebrowsing $safebrowse";
}

print "$output\n"; 
print "<br>";
######### Clamav Datenbanken ###########
print "<br><b>$Lang::tr{'clamav_database'}:</b>";
# Version der main-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/main.cld" ){ 
$output = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep main.cld | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
} 
elsif ( -e "/var/log/copfilter/default/opt/clamav/virdb/main.cvd" ){ 
$output = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep main.cvd | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
} 

#Version der daily-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/daily.cld" ){ 
$output = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep daily.cld | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
} 
elsif ( -e "/var/log/copfilter/default/opt/clamav/virdb/daily.cvd" ){ 
$output = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep daily.cvd | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
}

#Version der bytecode-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/bytecode.cld" ){ 
$output = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep bytecode.cld | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
} 
elsif ( -e "/var/log/copfilter/default/opt/clamav/virdb/bytecode.cvd" ){ 
$output = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep bytecode.cvd | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
}

######### Google Datenbank ###########
#Version der Safebrowsing-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/safebrowsing.cld" ){ 
$safebrowse = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep safebrowsing.cld | sed 's/  */ /g' | cut -d " " -f 6-`;

$safebrowse = &Header::cleanhtml($safebrowse,"y"); 
print "<br>";
print "<br><b>$Lang::tr{'google_database'}:</b>";
print "<br>$safebrowse\n"; 
} 
elsif ( -e "/var/log/copfilter/default/opt/clamav/virdb/safebrowsing.cvd" ){ 
$safebrowse = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep safebrowsing.cvd | sed 's/  */ /g' | cut -d " " -f 6-`;
$safebrowse = &Header::cleanhtml($safebrowse,"y"); 
print "<br>";
print "<br><b>$Lang::tr{'google_database'}:</b>";
print "<br>$safebrowse\n"; 
}

######### Sanesecurity Datenbanken ###########
#Version der Phishing-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/phish.ndb" ){ 
$phish = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep phish.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$phish = &Header::cleanhtml($phish,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Scam-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/scam.ndb" ){ 
$scam = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep scam.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
 
$scam = &Header::cleanhtml($scam,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  

#Version der Scamnailer-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/scamnailer.ndb" ){ 
$scamnailer = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep scamnailer.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$scamnailer = &Header::cleanhtml($scamnailer,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  


#Version der Spam-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spam.ldb" ){ 
$spam = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep spam.ldb | sed 's/  */ /g' | cut -d " " -f 6-`;
$spam = &Header::cleanhtml($spam,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der SpamImage-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spamimg.hdb" ){ 
$spamimg = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep spamimg.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
#$spamimg = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep spamimg.hdb |cut -c 36-61`; 
$spamimg = &Header::cleanhtml($spamimg,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  


#Version der Lott-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/lott.ndb" ){ 
$lott = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep lott.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$lott = &Header::cleanhtml($lott,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Filetype-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/filetype.ftm" ){ 
$filetype = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep filetype.ftm | sed 's/  */ /g' | cut -d " " -f 6-`;
$filetype = &Header::cleanhtml($filetype,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Spear-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spear.ndb" ){ 
$spear = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep spear.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$spear = &Header::cleanhtml($spear,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  

#Version der SpearLink-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spearl.ndb" ){ 
$spearl = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep spearl.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$spearl = &Header::cleanhtml($spearl,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  


#Version der Junk-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/junk.ndb" ){ 
$junk = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep junk.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$junk = &Header::cleanhtml($junk,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 


#Version der Junk-URLBLA-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/jurlbla.ndb" ){ 
$jurlbla = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep jurlbla.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$jurlbla = &Header::cleanhtml($jurlbla,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Junk-URLBL-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/jurlbl.ndb" ){ 
$jurlbl = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep jurlbl.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$jurlbl = &Header::cleanhtml($jurlbl,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Rogue-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/rogue.hdb" ){ 
$rogue = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep rogue.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$rogue = &Header::cleanhtml($rogue,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  

#Version der Spamattach-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spamattach.hdb" ){ 
$spamattach = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep spamattach.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$spamattach = &Header::cleanhtml($spamattach,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  

######### BOFHLAND Datenbanken ###########
#Version der Crash-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/bofcrack.ndb" ){ 
$bofcrack = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep bofcrack.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$bofcrack = &Header::cleanhtml($bofcrack,"y");
$bofhland = "$Lang::tr{'bofhland_database'}:";
} 

#Version der Mal-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/bofmal.ndb" ){ 
$bofmal = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep bofmal.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$bofmal = &Header::cleanhtml($bofmal,"y"); 
$bofhland = "$Lang::tr{'bofhland_database'}:";
} 

#Version der Phish-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/bofphsh.ndb" ){ 
$bofphish = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep bofphsh.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$bofphish = &Header::cleanhtml($bofphish,"y"); 
$bofhland = "$Lang::tr{'bofhland_database'}:";
}  

######## OITC Datenbanken #################

#Version der winnow_malware-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/wmal.hdb" ){ 
$wmal = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep wmal.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$wmal = &Header::cleanhtml($wmal,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
} 

#Version der winnow_phish-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/wphsh.ndb" ){ 
$wphsh = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep wphsh.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$wphsh = &Header::cleanhtml($wphsh,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
}  

#Version der winnow_spam-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/wspam.ndb" ){ 
$wspam = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep wspam.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$wspam = &Header::cleanhtml($wspam,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
} 

#Version der winnow_complex-pattern-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/wpatt.ldb" ){ 
$wpatt = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep wpatt.ldb | sed 's/  */ /g' | cut -d " " -f 6-`;
#$wpatt = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep wpatt.ldb |cut -c 36-58`; 
$wpatt = &Header::cleanhtml($wpatt,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
} 

#Version der winnow_attachment-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/wattach.hdb" ){ 
$wattach = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep wattach.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
#$wpatt = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep wattach.hdb |cut -c 36-58`; 
$wattach = &Header::cleanhtml($wattach,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
} 

############ Bill Landry Datenbanken ##################
#Version der INetMsg-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/inet.ndb" ){ 
$inet = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep inet.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$inet = &Header::cleanhtml($inet,"y"); 
$bland = "$Lang::tr{'bland_database'}:";
} 


######### MSRBL Datenbanken ###########
#Version der MSRBL-Spam-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/MSRBL_SPAM.ndb" ){ 
$msrblsp = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep MSRBL_SPAM.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$msrblsp = &Header::cleanhtml($msrblsp,"y");
$msrbldb = "$Lang::tr{'msrbl_database'}:";
} 

#Version der MSRBL-Images-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/MSRBL_Images.hdb" ){ 
$msrblim = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep MSRBL_Images.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$msrblim = &Header::cleanhtml($msrblim,"y"); 
$msrbldb = "$Lang::tr{'msrbl_database'}:"; 
} 

######### Andrew Lewis Datenbanken ###########
#Version der LW-Spam-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/LW_Scam.ndb" ){ 
$lwsp = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep LW_Scam.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$lwsp = &Header::cleanhtml($lwsp,"y");
$lwdb = "$Lang::tr{'lw_database'}:";
} 

#Version der LW-Images-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/LW_Image.hdb" ){ 
$lwim = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep LW_Image.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$lwim = &Header::cleanhtml($lwim,"y"); 
$lwdb = "$Lang::tr{'lw_database'}:"; 
} 

######## Julian Field Datenbanken #################
#Version der Scamnailer-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/scamnailer.ndb" ){ 
$scamnailer = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep scamnailer.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$scamnailer = &Header::cleanhtml($scamnailer,"y"); 
$jfld = "$Lang::tr{'jfld_database'}:";
}  

######## CRDF Datenbanken #################
#Version der CRDFAM-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/crdfam.hdb" ){ 
$crdfam = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep crdfam.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$crdfam = &Header::cleanhtml($crdfam,"y"); 
$crdf = "$Lang::tr{'crdf_database'}:";
}  

######### Securiteinfo Datenbanken ###########
#Version der batch-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/secinfobat.hdb" ){ 
$sibat = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep secinfobat.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sibat = &Header::cleanhtml($sibat,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der Secureteinfo-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/securiteinfo.hdb" ){ 
$sisecinf = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep securiteinfo.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sisecinf = &Header::cleanhtml($sisecinf,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der Honeynet-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/honeynet.hdb" ){ 
$sihon = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep honeynet.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sihon = &Header::cleanhtml($sihon,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der DOS-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/secinfodos.hdb" ){ 
$sidos = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep secinfodos.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sidos = &Header::cleanhtml($sidos,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der ELF-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/secinfoelf.hdb" ){ 
$sielf = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep secinfoelf.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sielf = &Header::cleanhtml($sielf,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der HTML-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/secinfohtm.hdb" ){ 
$sihtm = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep secinfohtm.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sihtm = &Header::cleanhtml($sihtm,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der Office-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/secinfooff.hdb" ){ 
$sioff = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep secinfooff.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sioff = &Header::cleanhtml($sioff,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der PDF-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/secinfopdf.hdb" ){ 
$sipdf = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep secinfopdf.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sipdf = &Header::cleanhtml($sipdf,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der BASH-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/secinfosh.hdb" ){ 
$sish = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep secinfosh.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sish = &Header::cleanhtml($sish,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

if ( ! $sidb eq '' ){
print "<br>";
print "<br><b>$sidb</b>";
	if ( ! $sibat eq ''){
		print "<br>$sibat";
	}
	if ( ! $sisecinf eq ''){
		print "<br>$sisecinf";
	}
	if ( ! $sihon eq ''){
		print "<br>$sihon";
	}
	if ( ! $sidos eq ''){
		print "<br>$sidos";
	}
	if ( ! $sielf eq ''){
		print "<br>$sielf";
	}
	if ( ! $sihtm eq ''){
		print "<br>$sihtm";
	}
	if ( ! $sioff eq ''){
		print "<br>$sioff";
	}
	if ( ! $sipdf eq ''){
		print "<br>$sipdf";
	}
	if ( ! $sish eq ''){
		print "<br>$sish";
	}
}

######### MalwarePatrol Datenbank ###########
#Version der Malware-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/mbl.ndb" ){ 
$mbl = `ls -la /var/log/copfilter/default/opt/clamav/virdb/ |grep mbl.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$mbl = &Header::cleanhtml($mbl,"y");
$mbldb = "$Lang::tr{'malware_database'}:"; 
} 

######### zum naechsten Update ################
if ($copfiltersettings{'CLAMD_UPDATE_METHOD'} eq "periodically") {
print "<br>";
print "<br>";
$output = `cat /var/log/copfilter/default/etc/clamd_counter`;
$output = $output + 5;
print "<b>$output</b>";
$output = $Lang::tr{'clamav_update'};
print "<b>$output</b>";
}


########### ClamAV ENDE ######################
print <<END
</td>
        <td valign='top'>
        <input type='radio' name='CLAMD_UPDATE_METHOD' value='periodically' $selected{'CLAMD_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='CLAMD_UPDATE_METHOD' value='manually'     $selected{'CLAMD_UPDATE_METHOD'}{'manually'}     />$Lang::tr{'copfilter disabled'}
	<br>
END
;
	if ( ! $sanesec eq ''){
		print "<br><b>Sanesecurity</b>";
	}
	if ( ! $spam eq '' ){
		print "<br>$spam";
	}
	if ( ! $spamimg eq '' ){
		print "<br>$spamimg";
	}
	if ( ! $spamattach eq '' ){
		print "<br>$spamattach";
	}
	if ( ! $lott eq '' ){
		print "<br>$lott";
	}
	if ( ! $spear eq '' ){
		print "<br>$spear";
	}
	if ( ! $spearl eq '' ){
		print "<br>$spearl";
	}
	if ( ! $junk eq '' ){
		print "<br>$junk";
	}
	if ( ! $scam eq '' ){
		print "<br>$scam";
	}
	if ( ! $phish eq '' ){
		print "<br>$phish";
	}
	if ( ! $rogue eq '' ){
		print "<br>$rogue";
	}
	if ( ! $jurlbl eq '' ){
		print "<br>$jurlbl";
	}
	if ( ! $jurlbla eq '' ){
		print "<br>$jurlbla";
	}
	if ( ! $filetype eq '' ){
		print "<br>$filetype";
	}

	if ( ! $jfld eq ''){
		print "<br>";
		print "<br><b>$jfld</b>";
	}
	if ( ! $scamnailer eq '' ){
		print "<br>$scamnailer";
	}
print <<END        
	<td valign='top'><input type='text' name='CLAMD_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'CLAMD_UPDATE_VALUE'}' />
        <select name='CLAMD_UPDATE_PERIOD'>
                <option value='minutely' $selected{'CLAMD_UPDATE_PERIOD'}{'minutely'}>$Lang::tr{'copfilter minutes'}</option>
                <option value='hourly' $selected{'CLAMD_UPDATE_PERIOD'}{'hourly'}>$Lang::tr{'copfilter hours'}</option>
                <option value='daily' $selected{'CLAMD_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'CLAMD_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'CLAMD_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>
        </select>
END
;

	if ( ! $oitc eq ''){
		print "<br>";
		print "<br>";
		print "<br><b>$oitc</b>";
	}
	if ( ! $wspam eq '' ){
		print "<br>$wspam";
	}
	if ( ! $wphsh eq '' ){
		print "<br>$wphsh";
	}
	if ( ! $wmal eq '' ){
		print "<br>$wmal";
	}
	if ( ! $wpatt eq '' ){
		print "<br>$wpatt";
	}
	if ( ! $wattach eq '' ){
		print "<br>$wattach";
	}


	if ( ! $lwdb eq ''){
	print "<br>";
	print "<br><b>$lwdb</b>";
		if ( ! $lwsp eq ''){
			print "<br>$lwsp";
		}
		if ( ! $lwim eq ''){
			print "<br>$lwim";
		}
	}
	if ( ! $crdf eq ''){
		print "<br>";
		print "<br><b>$crdf</b>";
		if ( ! $crdfam eq ''){
			print "<br>$crdfam";
		} 
	}
	if ( ! $bland eq ''){
		print "<br>";
		print "<br><b>$bland</b>";
	}
	if ( ! $inet eq '' ){
		print "<br>$inet";
	}

print <<END        
        <td valign='top' align='left'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter clamd update now'}' /> 
END
;
if ( -e "${copfilter_swroot}/etc/copfilter_check-updates_clamav.done" ){
   print "<font color='#339933'>DONE</font>";
   system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_check-updates_clamav.done");
}

	if ( ! $msrbldb eq ''){
	print "<br>";
	print "<br>";
	print "<br><b>$msrbldb</b>";
		if ( ! $msrblsp eq ''){
			print "<br>$msrblsp";
		}
		if ( ! $msrblim eq ''){
			print "<br>$msrblim";
		}
	}
	if ( ! $mbldb eq ''){
	print "<br>";
	print "<br><b>$mbldb</b>";
		if ( ! $mbl eq ''){
			print "<br>$mbl";
		} 
	}
	if ( ! $bofhland eq ''){
	print "<br>";
	print "<br><b>$bofhland</b>";
		if ( ! $bofcrack eq ''){
			print "<br>$bofcrack";
		} 
		if ( ! $bofmal eq ''){
			print "<br>$bofmal";
		} 
		if ( ! $bofphish eq ''){
			print "<br>$bofphish";
		} 
	}

print <<END

<tr>
<tr>
        <td> <select name='CLAMD_PHISHING_SIGS'>
             <option value='off' $selected{'CLAMD_PHISHING_SIGS'}{'off'}>off</option>
             <option value='on' $selected{'CLAMD_PHISHING_SIGS'}{'on'}>on</option> </select>
	$Lang::tr{'copfilter clamd phishing_sigs'}
END
;

if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq 'on' ) {
print " ******";
}

if ($copfiltersettings{'CLAMD_PHISHING_SIGS'} eq 'on' ) {
print <<END
	<td><td> <select name='THRDP_SHOW_GUI_ENABLE'>
             <option value='off' $selected{'THRDP_SHOW_GUI_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SHOW_GUI_ENABLE'}{'on'}>on</option> </select>
	$Lang::tr{'copfilter clamd thrdp_gui'}</td></td>

END
;
}

if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq 'on' ) {
print <<END
</table>
<hr />
<table>
<table width='100%' border='0' cellpadding='2'>
<tr>
        <td width='20%'></td>
        <td width='20%'></td>
        <td width='20%'></td>
        <td width='20%'></td>
        <td width='20%'></td>
</tr>
        <td colspan='2'>

	<a href='http://www.sanesecurity.com/databases.htm' target='_blank'><b>$Lang::tr{'copfilter clamd thrdp_info5'}</b> ****

	 <td><select name='THRDP_MAIL_NOTIF_ENABLE'>
             <option value='off' $selected{'THRDP_MAIL_NOTIF_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_MAIL_NOTIF_ENABLE'}{'on'}>on</option> </select>
	$Lang::tr{'copfilter clamd thrdp_notif'}</td>
END
;	
}

if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq 'on' ) {
	if ( system ('/bin/grep "THRDP_ADD_INFO_ENABLE" /var/log/copfilter/default/etc2/copfilter_functions &>/dev/null 2>&1') eq 0){
print <<END
	 <td colspan='2'><select name='THRDP_ADD_INFO_ENABLE'>
             <option value='off' $selected{'THRDP_ADD_INFO_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_ADD_INFO_ENABLE'}{'on'}>on</option> </select>
	$Lang::tr{'copfilter clamd add_info'}</td>
END
;
}
}
if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq 'on' ) {
print <<END
	<tr><tr><td><a href='http://www.sanesecurity.com/' target='_blank'><b>Sanesecurity</b>
	<td><a href='http://www.sanesecurity.com/databases.htm' target='_blank'><b>OITC</b> *****
	<td><a href='http://www.sanesecurity.com/databases.htm' target='_blank'><b>CRDF</b> *****
	<td><a href='http://www.securiteinfo.com/services/clamav_unofficial_malwares_signatures.shtml' target='_blank'><b>SecuriteInfo</b>
	<td><a href='http://www.msrbl.com' target='_blank'><b>MSRBL</b>
	<tr>
	<td><select name='THRDP_SPAM_ENABLE'>
             <option value='off' $selected{'THRDP_SPAM_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SPAM_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SPAM_ENABLE'}{'havp'}>havp</option> </select>
	spam.ldb</td>
	<td><select name='THRDP_WSPAM_ENABLE'>
             <option value='off' $selected{'THRDP_WSPAM_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_WSPAM_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_WSPAM_ENABLE'}{'havp'}>havp</option> </select>
	winnow_spam_complete.ndb</td>
	<td><select name='THRDP_CRDFAM_ENABLE'>
             <option value='off' $selected{'THRDP_CRDFAM_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_CRDFAM_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_CRDFAM_ENABLE'}{'havp'}>havp</option> </select>
	crdfam.clamav.hdb</td>
	<td><select name='THRDP_SECURITEINFO_ENABLE'>
             <option value='off' $selected{'THRDP_SECURITEINFO_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SECURITEINFO_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SECURITEINFO_ENABLE'}{'havp'}>havp</option> </select>
	securiteinfo.hdb</td>
	<td><select name='THRDP_MSRBL_SPAM_ENABLE'>
             <option value='off' $selected{'THRDP_MSRBL_SPAM_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_MSRBL_SPAM_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_MSRBL_SPAM_ENABLE'}{'havp'}>havp</option> </select>
	MSRBL-SPAM.ndb</td>
	<tr>
	<td><select name='THRDP_SPAMIMG_ENABLE'>
             <option value='off' $selected{'THRDP_SPAMIMG_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SPAMIMG_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SPAMIMG_ENABLE'}{'havp'}>havp</option> </select>
	spamimg.hdb</td>
	<td><select name='THRDP_WPHSH_ENABLE'>
             <option value='off' $selected{'THRDP_WPHSH_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_WPHSH_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_WPHSH_ENABLE'}{'havp'}>havp</option> </select>
	winnow_phish_complete.ndb</td>
	<td><a href='http://www.sanesecurity.com/databases.htm' target='_blank'><b>Julian Field</b> *****</td>
	<td><select name='THRDP_HONEYNET_ENABLE'>
             <option value='off' $selected{'THRDP_HONEYNET_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_HONEYNET_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_HONEYNET_ENABLE'}{'havp'}>havp</option> </select>
	honeynet.hdb</td>
	<td><select name='THRDP_MSRBL_IMAGES_ENABLE'>
             <option value='off' $selected{'THRDP_MSRBL_IMAGES_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_MSRBL_IMAGES_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_MSRBL_IMAGES_ENABLE'}{'havp'}>havp</option> </select>
	MSRBL-Images-FULL-SoN.hdb</td>
	<tr>
	<td><select name='THRDP_LOTT_ENABLE'>
             <option value='off' $selected{'THRDP_LOTT_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_LOTT_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_LOTT_ENABLE'}{'havp'}>havp</option> </select>
	lott.ndb</td>
	<td><select name='THRDP_WMAL_ENABLE'>
             <option value='off' $selected{'THRDP_WMAL_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_WMAL_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_WMAL_ENABLE'}{'havp'}>havp</option> </select>
	winnow_malware.hdb</td>
	<td><select name='THRDP_SCAMNAILER_ENABLE'>
             <option value='off' $selected{'THRDP_SCAMNAILER_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SCAMNAILER_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SCAMNAILER_ENABLE'}{'havp'}>havp</option> </select>
	scamnailer.ndb</td>
	<td><select name='THRDP_SECINFOBAT_ENABLE'>
             <option value='off' $selected{'THRDP_SECINFOBAT_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SECINFOBAT_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SECINFOBAT_ENABLE'}{'havp'}>havp</option> </select>
	securiteinfobat.hdb</td>
	<td><a href='http://www.malware.com.br' target='_blank'><b>Malware Patrol</b></td>
	<tr>
	<td><select name='THRDP_SPEAR_ENABLE'>
             <option value='off' $selected{'THRDP_SPEAR_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SPEAR_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SPEAR_ENABLE'}{'havp'}>havp</option> </select>
	spear.ndb</td>
	<td><select name='THRDP_WPATT_ENABLE'>
             <option value='off' $selected{'THRDP_WPATT_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_WPATT_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_WPATT_ENABLE'}{'havp'}>havp</option> </select>
	winnow.complex.patterns.ldb</td>
	<td><a href='http://clamav.bofhland.org' target='_blank'><b>BOFHLAND</b> *****</td>
	<td><select name='THRDP_SECINFODOS_ENABLE'>
             <option value='off' $selected{'THRDP_SECINFODOS_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SECINFODOS_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SECINFODOS_ENABLE'}{'havp'}>havp</option> </select>
	securiteinfodos.hdb</td></td>
	<td><select name='THRDP_MBL_ENABLE'>
             <option value='off' $selected{'THRDP_MBL_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_MBL_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_MBL_ENABLE'}{'havp'}>havp</option> </select>
	mbl.ndb</td>
	<tr>
	<td><select name='THRDP_SPEARL_ENABLE'>
             <option value='off' $selected{'THRDP_SPEARL_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SPEARL_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SPEARL_ENABLE'}{'havp'}>havp</option> </select>
	spearl.ndb</td>
	<td><select name='THRDP_WATTACH_ENABLE'>
             <option value='off' $selected{'THRDP_WATTACH_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_WATTACH_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_WATTACH_ENABLE'}{'havp'}>havp</option> </select>
	winnow.attachments.hdb</td>
	<td><select name='THRDP_BOFCRACK_ENABLE'>
             <option value='off' $selected{'THRDP_BOFCRACK_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_BOFCRACK_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_BOFCRACK_ENABLE'}{'havp'}>havp</option> </select>
	bofhland_cracked_URL.ndb</td>
	<td><select name='THRDP_SECINFOELF_ENABLE'>
             <option value='off' $selected{'THRDP_SECINFOELF_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SECINFOELF_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SECINFOELF_ENABLE'}{'havp'}>havp</option> </select>
	securiteinfoelf.hdb</td></td>

	<tr>
	<td><select name='THRDP_JUNK_ENABLE'>
             <option value='off' $selected{'THRDP_JUNK_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_JUNK_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_JUNK_ENABLE'}{'havp'}>havp</option> </select>
	junk.ndb</td>
	<td><a href='http://www.sanesecurity.com/databases.htm' target='_blank'><b>Andrew Lewis</b> *****</td>
	<td><select name='THRDP_BOFMAL_ENABLE'>
             <option value='off' $selected{'THRDP_BOFMAL_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_BOFMAL_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_BOFMAL_ENABLE'}{'havp'}>havp</option> </select>
	bofhland_malware_URL.ndb</td></td>
	<td><select name='THRDP_SECINFOHTM_ENABLE'>
             <option value='off' $selected{'THRDP_SECINFOHTM_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SECINFOHTM_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SECINFOHTM_ENABLE'}{'havp'}>havp</option> </select>
	securiteinfohtml.hdb</td></td>
	<tr>
	<td><select name='THRDP_SCAM_ENABLE'>
             <option value='off' $selected{'THRDP_SCAM_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SCAM_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SCAM_ENABLE'}{'havp'}>havp</option> </select>
	scam.ndb</td>
	<td><select name='THRDP_LW_SCAM_ENABLE'>
             <option value='off' $selected{'THRDP_LW_SCAM_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_LW_SCAM_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_LW_SCAM_ENABLE'}{'havp'}>havp</option> </select>
	doppelstern.ndb</td>
	<td><select name='THRDP_BOFPHSH_ENABLE'>
             <option value='off' $selected{'THRDP_BOFPHSH_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_BOFPHSH_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_BOFPHSH_ENABLE'}{'havp'}>havp</option> </select>
	bofhland_phishing_URL.ndb</td></td>
	<td><select name='THRDP_SECINFOOFF_ENABLE'>
             <option value='off' $selected{'THRDP_SECINFOOFF_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SECINFOOFF_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SECINFOOFF_ENABLE'}{'havp'}>havp</option> </select>
	securiteinfooffice.hdb</td></td>
	<tr>
	<td><select name='THRDP_PHISH_ENABLE'>
             <option value='off' $selected{'THRDP_PHISH_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_PHISH_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_PHISH_ENABLE'}{'havp'}>havp</option> </select>
	phish.ndb</td>
	<td><select name='THRDP_LW_IMAGE_ENABLE'>
             <option value='off' $selected{'THRDP_LW_IMAGE_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_LW_IMAGE_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_LW_IMAGE_ENABLE'}{'havp'}>havp</option> </select>
	doppelstern.hdb</td>
	<td><td><select name='THRDP_SECINFOPDF_ENABLE'>
             <option value='off' $selected{'THRDP_SECINFOPDF_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SECINFOPDF_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SECINFOPDF_ENABLE'}{'havp'}>havp</option> </select>
	securiteinfopdf.hdb</td></td>
	<tr>
	<td><select name='THRDP_ROGUE_ENABLE'>
             <option value='off' $selected{'THRDP_ROGUE_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_ROGUE_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_ROGUE_ENABLE'}{'havp'}>havp</option> </select>
	rogue.hdb</td>
	<td><a href='http://www.sanesecurity.com/databases.htm' target='_blank'><b>Bill Landry</b> *****</td>
	<td><td><select name='THRDP_SECINFOSH_ENABLE'>
             <option value='off' $selected{'THRDP_SECINFOSH_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SECINFOSH_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SECINFOSH_ENABLE'}{'havp'}>havp</option> </select>
	securiteinfosh.hdb</td></td>
	<tr>
	<td><select name='THRDP_JURLBLA_ENABLE'>
             <option value='off' $selected{'THRDP_JURLBLA_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_JURLBLA_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_JURLBLA_ENABLE'}{'havp'}>havp</option> </select>
	jurlbla.ndb</td>
	<td><select name='THRDP_INET_ENABLE'>
             <option value='off' $selected{'THRDP_INET_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_INET_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_INET_ENABLE'}{'havp'}>havp</option> </select>
	INetMsg-SpamDomains-2w.ndb</td>
	<tr>
	<td><select name='THRDP_JURLBL_ENABLE'>
             <option value='off' $selected{'THRDP_JURLBL_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_JURLBL_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_JURLBL_ENABLE'}{'havp'}>havp</option> </select>
	jurlbl.ndb</td>
	<tr>
	<td><select name='THRDP_SPAMATTACH_ENABLE'>
             <option value='off' $selected{'THRDP_SPAMATTACH_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_SPAMATTACH_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_SPAMATTACH_ENABLE'}{'havp'}>havp</option> </select>
	spamattach.hdb</td>
	<tr>
	<td><select name='THRDP_FILETYPE_ENABLE'>
             <option value='off' $selected{'THRDP_FILETYPE_ENABLE'}{'off'}>off</option>
             <option value='on' $selected{'THRDP_FILETYPE_ENABLE'}{'on'}>on</option>
             <option value='havp' $selected{'THRDP_FILETYPE_ENABLE'}{'havp'}>havp</option> </select>
	sanesecurity.ftm</td>
	<td><td><td colspan='1'><a href='http://www.sanesecurity.com/status.htm' target='_blank'><b>Sanesecurity Status Info</b></td></td>
	<td colspan='2'><b>$Lang::tr{'copfilter clamd thrdp_info6'}</b></td></td>
</table>
<hr />
<table>
<table width='100%' border='0' cellpadding='2'>
<tr>
        <td width='28%'></td>
        <td width='5%'></td>
        <td width='23%'></td>
        <td width='24%'></td>
        <td width='20%'></td>
</tr>
        <td colspan='2'>
END
;
}


print <<END
    </td>
</tr></tr>

<tr>
        <td>&nbsp;</td>
</tr>
<tr>
        <td>&nbsp;</td>
</tr>
END
;

##### AVG

if ($copfiltersettings{'AVG_INSTALLED'} eq 'yes' ) {
print <<END

<tr>
	<td><u><b>AVG:</b></u> &nbsp; &nbsp; &nbsp;
       	     <select name='AVG_ENABLE'>
             <option value='on' $selected{'AVG_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'AVG_ENABLE'}{'off'}>off</option> </select> 
        </td>
</tr>
<tr><td></td></tr>
<tr>
        <td colspan='2'><b>$Lang::tr{'copfilter avg_sig'}:</b></td>
        <td colspan='2'><b>$Lang::tr{'copfilter automatic update'}:</b></td>
        <td colspan='1'><b>$Lang::tr{'copfilter manual update'}:</b></td>
</tr>
<tr>
        <td colspan='2'>
END
;
$output = `cat /var/log/copfilter/default/opt/avg/CURRENTVERSION |/bin/grep -Ev "^L|^E|^V|^\$"  |/bin/sed -e 's/,/ -/' -e 's/engine/Engine/' -e 's/Program version /AVG /' -e 'a\<br>'`;
print "$output";
$output = `cat /var/log/copfilter/default/opt/avg/CURRENTVERSION |/bin/grep -Ev "^L|^E|^P|^\$"  |/bin/sed -e 's/: Version//' -e 's/Database/Database/' | cut -d " " -f -3`;
print "$output";
#Version der Datenbank
if ( -e "/var/log/copfilter/default/opt/avg/default/data/incavi.avm" ){ 
$output = ` ls -la /var/log/copfilter/default/opt/avg/default/data/ |grep incavi.avm | sed -e '/~/d' | sed 's/  */ /g' | cut -d " " -f 6-8`; 
$output = &Header::cleanhtml($output,"y"); 
print "$output\n"; 
} 
elsif ( -e "/var/log/copfilter/default/opt/avg/default/data/upd_vers.cfg" ){ 
$output = `ls -la /var/log/copfilter/default/opt/avg/default/data/ |grep upd_vers.cfg | sed 's/  */ /g' | cut -d " " -f 6-8`; 
$output = &Header::cleanhtml($output,"y"); 
print "$output\n"; 
}
$output = `cat /var/log/copfilter/default/opt/avg/CURRENTVERSION |/bin/grep -Ev "type|^V|^P|^\$" `;
print "<br>$output\n";

if ($copfiltersettings{'AVG_UPDATE_METHOD'} eq "periodically") {
#print "<br>";
print "<br>";
$output = `cat /var/log/copfilter/default/etc/avg_counter`;
$output = $output + 5;
print "<b>$output</b>";
$output = $Lang::tr{'avg_update'};
print "<b>$output</b>";
}


print <<END
</font>
</td>
        <td valign='top'><input type='radio' name='AVG_UPDATE_METHOD' value='periodically' $selected{'AVG_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='AVG_UPDATE_METHOD' value='manually' $selected{'AVG_UPDATE_METHOD'}{'manually'} />$Lang::tr{'copfilter disabled'}</td>
        <td valign='top'><input type='text' name='AVG_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'AVG_UPDATE_VALUE'}' />
        <select name='AVG_UPDATE_PERIOD'>
                <option value='minutely' $selected{'AVG_UPDATE_PERIOD'}{'minutely'}>$Lang::tr{'copfilter minutes'}</option>
                <option value='hourly' $selected{'AVG_UPDATE_PERIOD'}{'hourly'}>$Lang::tr{'copfilter hours'}</option>
                <option value='daily' $selected{'AVG_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'AVG_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'AVG_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>
        </select></td>
        <td valign='top'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter avg update now'}' />
END
;
if ( -e "${copfilter_swroot}/etc/copfilter_check-updates_avg.done" ){
   print "<font color='#339933'>DONE</font>";
   system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_check-updates_avg.done");
}

print <<END

	</td>
</tr>
<tr><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td></tr>
END
;

}


##### FPROT

if ($copfiltersettings{'FPROT_INSTALLED'} eq 'yes' ) {
print <<END

<tr>
	<td><u><b>F-PROT:</b></u> &nbsp; &nbsp; &nbsp;
       	     <select name='FPROT_ENABLE'>
             <option value='on' $selected{'FPROT_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'FPROT_ENABLE'}{'off'}>off</option> </select> 
        </td>
</tr>
<tr><td></td></tr>
<tr>
        <td colspan='2'><b>$Lang::tr{'copfilter fprot_sig'}:</b></td>
        <td colspan='2'><b>$Lang::tr{'copfilter automatic update'}:</b></td>
        <td colspan='1'><b>$Lang::tr{'copfilter manual update'}:</b></td>
</tr>
<tr>
        <td colspan='2'>
END
;
$output = `cat /var/log/copfilter/default/opt/f-prot/CURRENTVERSION |/bin/grep -E "^F-P" | cut -c 1-35 | sed -e 's/Antivirus version //'`;
print "$output\n";
$output = " - ";
print "$output\n";
$output = `cat /var/log/copfilter/default/opt/f-prot/CURRENTVERSION |/bin/grep -E "^E" |/bin/sed -e 'a\<br>' | sed -e 's/ version://'`;
print "$output\n";
$output = "Virus Database from ";
print "$output";
$output = `ls -la /var/log/copfilter/default/opt/f-prot/default/ |grep antivir.def | sed 's/  */ /g' | cut -d " " -f 6-8`;
print "$output\n";
$output = `cat /var/log/copfilter/default/opt/f-prot/CURRENTVERSION |/bin/grep -E "^Li" |/bin/sed -e 'a\<br>'`;
print "<br>$output";

if ($copfiltersettings{'FPROT_UPDATE_METHOD'} eq "periodically") {
#print "<br>";
print "<br>";
$output = `cat /var/log/copfilter/default/etc/fprot_counter`;
$output = $output + 5;
print "<b>$output</b>";
$output = $Lang::tr{'fprot_update'};
print "<b>$output</b>";
}

print <<END
</font>
</td>
        <td valign='top'><input type='radio' name='FPROT_UPDATE_METHOD' value='periodically' $selected{'FPROT_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='FPROT_UPDATE_METHOD' value='manually' $selected{'FPROT_UPDATE_METHOD'}{'manually'} />$Lang::tr{'copfilter disabled'}</td>
        <td valign='top'><input type='text' name='FPROT_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'FPROT_UPDATE_VALUE'}' />
        <select name='FPROT_UPDATE_PERIOD'>
                <option value='minutely' $selected{'FPROT_UPDATE_PERIOD'}{'minutely'}>$Lang::tr{'copfilter minutes'}</option>
                <option value='hourly' $selected{'FPROT_UPDATE_PERIOD'}{'hourly'}>$Lang::tr{'copfilter hours'}</option>
                <option value='daily' $selected{'FPROT_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'FPROT_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'FPROT_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>
        </select></td>
        <td valign='top'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter fprot update now'}' />
END
;
if ( -e "${copfilter_swroot}/etc/copfilter_check-updates_f-prot.done" ){
   print "<font color='#339933'>DONE</font>";
   system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_check-updates_f-prot.done");
}

print <<END

	</td>
</tr>
END
;

}

print <<END
<tr>
        <td>&nbsp; </td>
</tr>
<a name='renattach' />
<tr><td colspan='2'><u><b>$Lang::tr{'copfilter attachment renamer'}:</b></u></td></tr>
<tr>
    <td colspan='4'>$Lang::tr{'copfilter attachment renamer2'}</td>
</tr>

<tr>
    <td colspan='4'> $Lang::tr{'copfilter antivirus note'} </td>
</tr>


<tr>
        <td colspan='3'>$Lang::tr{'copfilter antivirus restart'} <br /> $Lang::tr{'copfilter automatic update email'}
END
;
if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq 'on' ) {
print <<END
	<br /> $Lang::tr{'copfilter clamd thrdp_info'} <br /> $Lang::tr{'copfilter clamd thrdp_info2'}
	<br /> $Lang::tr{'copfilter clamd thrdp_info3'} <br /> $Lang::tr{'copfilter clamd thrdp_info4'}
	<br /> $Lang::tr{'copfilter clamd thrdp_info8'}
END
;
}
print <<END
</td> 

</tr>
<tr>        <td colspan='3'>
            <input type='checkbox' name='SKIP_RESTART' />
             $Lang::tr{'copfilter skip restart'}
        </td>
</tr>

<tr>
        <td colspan='2'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter save'}' /> </td>
        <td> </td>
        <td> </td>
        <td> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter show virus quarantine'}' /> </td>
</tr>
</table>
END
;

print "</form>\n";
&Header::closebox();
print "<br />\n";



# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
