#!/bin/sh

# http://www.exit0.us/index.php?pagename=RulesDuJour
# http://wiki.apache.org/spamassassin/CustomRulesets
# http://www.rulesemporium.com/rules.htm

. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh


if [ ! -f /var/ipcop/red/active ] ; then
   echo "no internet connection available, so no updates will be downloaded" |logger -t "copfilter updates spamassassin $APPEND"
   exit
fi

if [ "x${RULES_DU_JOUR_ENABLE}" = "xoff" ] ; then
   echo "will not update since rules_du_jour is OFF" |logger -t "copfilter updates spamassassin $APPEND"
   exit
fi

if [ "x$1" = "xweboutput" ]; then
  APPEND="<BR>"
fi

echo "rules_du_jour updating ... " |logger -t "copfilter updates spamassassin"


TMP_FILE1a=$TMPDIR/rules_du_jour.tmp1a
TMP_FILE1b=$TMPDIR/rules_du_jour.tmp1b
TMP_FILE2a=$TMPDIR/rules_du_jour.tmp2a
TMP_FILE2b=$TMPDIR/rules_du_jour.tmp2b
#TMP_FILE3=$TMPDIR/rules_du_jour.tmp3
TMP_FILE4=$TMPDIR/rules_du_jour.tmp4


RULEDIR=$BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin

echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-" > $TMP_FILE4
echo >> $TMP_FILE4
echo $CP_rules_update_mail >> $TMP_FILE4
echo >> $TMP_FILE4
echo >> $TMP_FILE4


      
        RESULT1=1
        RESULT2=1

        # Update SPAMASSASSIN channel
        cd $RULEDIR/updates_spamassassin/updates_spamassassin_org
        ls -la *.cf >$TMP_FILE1a
        if [ "x${SPAMD_ENABLE}" = "xon" ];then
            $BASEDIR/opt/mail-spamassassin/default/bin/sa-update --nogpg --allowplugins --channel updates.spamassassin.org --updatedir $RULEDIR/updates_spamassassin
            RESULT1=$?
        fi
        ls  -la *.cf >$TMP_FILE2a

        # Update SARE channel
        cd $RULEDIR/updates_openprotect_com/saupdates_openprotect_com
        ls -la *.cf >$TMP_FILE1b
        if [ "x${RULES_DU_JOUR_ENABLE}" = "xon" ];then
                $BASEDIR/opt/mail-spamassassin/default/bin/sa-update --nogpg --allowplugins --channel saupdates.openprotect.com --updatedir $RULEDIR/updates_openprotect_com
            RESULT2=$?
        fi
        ls  -la *.cf >$TMP_FILE2b

        chown -R spam.spam  $RULEDIR

         if [ "x${RESULT1}" = "x0" -o "x${RESULT2}" = "x0" ];then
             /etc/rc.d/init.d/copfilter_spamd restart | logger -t "copfilter updates spamassassin"
         fi



echo "$CP_rules1a" >> $TMP_FILE4 
diff $TMP_FILE1a $TMP_FILE2a |sed -e 's/^[0-9].*/\n/' >> $TMP_FILE4
echo >>  $TMP_FILE4 
echo >>  $TMP_FILE4 
echo >>  $TMP_FILE4 
echo "$CP_rules1b" >> $TMP_FILE4 
diff $TMP_FILE1b $TMP_FILE2b |sed -e 's/^[0-9].*/\n/' >> $TMP_FILE4
echo >>  $TMP_FILE4 
echo >>  $TMP_FILE4 
echo >>  $TMP_FILE4 
echo "$CP_rules2" >> $TMP_FILE4 
ls -laR [!l]*.cf >>$TMP_FILE4
echo >>  $TMP_FILE4 
echo >>  $TMP_FILE4 
echo >>  $TMP_FILE4 
#echo "$CP_rules3" >> $TMP_FILE4 
#cat $TMP_FILE3 >>  $TMP_FILE4 


diff $TMP_FILE1a $TMP_FILE2a &>/dev/null
RESULT1=$?

diff $TMP_FILE1b $TMP_FILE2b &>/dev/null
RESULT2=$?

if [ "x${RESULT1}" = "x1" -o "x${RESULT2}" = "x1" ]; then
  echo "updates available:" |logger -t "copfilter updates spamassassin"

  if [ "x${SMTP_HOST}" = "x" -o "x${EMAIL_ADR}" = "x" ] ; then
    echo "no email notification will be sent, since SMTP_HOST and/or EMAIL_ADR where not specified" | logger -t "copfilter updates spamassassin"
  else
   if [ "x$UPDATE_MAIL_NOTIF" = "xoff" ]; then
        echo "no email notification will be sent, since this feature will be enabled" | logger -t "copfilter updates spamassassin"
   else
    cat $TMP_FILE4 | logger -t "copfilter updates spamassassin"


    if [ -f $BASEDIR/etc/smtp_auth_enable ]; then
         echo "smtp authentication enabled, using user: $SMTP_AUTH_USER"
         cat $TMP_FILE4 | $SENDEMAIL -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
                          -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"         \
                          -u "[Copfilter] AntiSpam Update: Rules Du Jour" | logger -t "copfilter updates spamassassin"
    else
         cat $TMP_FILE4 | $SENDEMAIL -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"         \
                          -u "[Copfilter] AntiSpam Update: Rules Du Jour" | logger -t "copfilter updates spamassassin"

    fi
  fi
  fi
else
  echo "no newer updates available" |logger -t "copfilter updates spamassassin"
fi



echo "done " |logger -t "copfilter updates spamassassin"


#cleanup
rm -f $TMP_FILE1a
rm -f $TMP_FILE1b
rm -f $TMP_FILE2a
rm -f $TMP_FILE2b
#rm -f $TMP_FILE3
rm -f $TMP_FILE4
